PATH:
usr
/
bin
#!/usr/bin/bash set -ue # Copyright (C) 2017-2024 MariaDB # Copyright (C) 2013 Percona Inc # # This program is free software; you can redistribute it and/or modify # it under the terms of the GNU General Public License as published by # the Free Software Foundation; version 2 of the License. # # This program is distributed in the hope that it will be useful, # but WITHOUT ANY WARRANTY; without even the implied warranty of # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the # GNU General Public License for more details. # # You should have received a copy of the GNU General Public License # along with this program; see the file COPYING. If not, write to the # Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston # MA 02110-1335 USA. # This is a reference script for mariadb-backup-based state snapshot transfer. # Documentation: # https://mariadb.com/kb/en/mariabackup-overview/ # Make sure to read that before proceeding! . $(dirname "$0")/wsrep_sst_common BACKUP_BIN=$(commandex 'mariadb-backup') if [ -z "$BACKUP_BIN" ]; then wsrep_log_error 'mariadb-backup binary not found in path' exit 42 fi BACKUP_PID="" INFO_FILE='xtrabackup_galera_info' DONOR_INFO_FILE='donor_galera_info' IST_FILE='xtrabackup_ist' MAGIC_FILE="$DATA/$INFO_FILE" DONOR_MAGIC_FILE="$DATA/$DONOR_INFO_FILE" ealgo="" eformat="" ekey="" ekeyfile="" encrypt=0 ssyslog="" ssystag="" tcert="" tcap="" tpem="" tkey="" tmode="" sockopt="" progress="" ttime=0 totime=0 lsn="" ecmd="" rlimit="" # Initially stagemsg="$WSREP_SST_OPT_ROLE" cpat="" speciald=1 ib_home_dir="" ib_log_dir="" ib_undo_dir="" ar_log_dir="" sfmt="" strmcmd="" tfmt="" tcmd="" payload=0 pvformat="-F '%N => Rate:%r Avg:%a Elapsed:%t %e Bytes: %b %p'" pvopts="-f -i 10 -N $WSREP_SST_OPT_ROLE" uextra=0 disver="" STATDIR="" tmpopts="" itmpdir="" xtmpdir="" scomp="" sdecomp="" ssl_dhparams="" compress='none' compress_chunk="" compress_threads="" backup_threads="" encrypt_threads="" encrypt_chunk="" readonly SECRET_TAG='secret' readonly TOTAL_TAG='total' # Required for backup locks # For backup locks it is 1 sent by joiner sst_ver=1 INNOAPPLYLOG="$DATA/mariabackup.prepare.log" INNOMOVELOG="$DATA/mariabackup.move.log" INNOBACKUPLOG="$DATA/mariabackup.backup.log" timeit() { local stage="$1" shift local cmd="$@" local x1 x2 took extcode if [ $ttime -eq 1 ]; then x1=$(date +%s) fi wsrep_log_info "Evaluating $cmd" eval $cmd extcode=$? if [ $ttime -eq 1 ]; then x2=$(date +%s) took=$(( x2-x1 )) wsrep_log_info "NOTE: $stage took $took seconds" totime=$(( totime+took )) fi return $extcode } get_keys() { # $encrypt -eq 1 is for internal purposes only if [ $encrypt -ge 2 -o $encrypt -eq -1 ]; then return fi if [ $encrypt -eq 0 ]; then if [ -n "$ealgo" -o -n "$ekey" -o -n "$ekeyfile" ]; then wsrep_log_error "Options for encryption are specified," \ "but encryption itself is disabled. SST may fail." fi return fi if [ "$sfmt" = 'tar' ]; then wsrep_log_info "NOTE: key-based encryption (encrypt=1)" \ "cannot be enabled with tar format" encrypt=-1 return fi wsrep_log_info "Key based encryption enabled in my.cnf" if [ -z "$ealgo" ]; then wsrep_log_error "FATAL: Encryption algorithm empty from my.cnf, bailing out" exit 3 fi if [ -z "$ekey" -a ! -r "$ekeyfile" ]; then wsrep_log_error "FATAL: Either key must be specified" \ "or keyfile must be readable" exit 3 fi if [ "$eformat" = 'openssl' ]; then get_openssl if [ -z "$OPENSSL_BINARY" ]; then wsrep_log_error "If encryption using the openssl is enabled," \ "then you need to install openssl" exit 2 fi ecmd="'$OPENSSL_BINARY' enc -$ealgo" if "$OPENSSL_BINARY" enc -help 2>&1 | grep -qw -F -- '-pbkdf2'; then ecmd="$ecmd -pbkdf2" elif "$OPENSSL_BINARY" enc -help 2>&1 | grep -qw -F -- '-iter'; then ecmd="$ecmd -iter 1" elif "$OPENSSL_BINARY" enc -help 2>&1 | grep -qw -F -- '-md'; then ecmd="$ecmd -md sha256" fi if [ -z "$ekey" ]; then ecmd="$ecmd -kfile '$ekeyfile'" else ecmd="$ecmd -k '$ekey'" fi elif [ "$eformat" = 'xbcrypt' ]; then if [ -z "$(commandex xbcrypt)" ]; then wsrep_log_error "If encryption using the xbcrypt is enabled," \ "then you need to install xbcrypt" exit 2 fi wsrep_log_info "NOTE: xbcrypt-based encryption," \ "supported only from Xtrabackup 2.1.4" if [ -z "$ekey" ]; then ecmd="xbcrypt --encrypt-algo='$ealgo' --encrypt-key-file='$ekeyfile'" else ecmd="xbcrypt --encrypt-algo='$ealgo' --encrypt-key='$ekey'" fi if [ -n "$encrypt_threads" ]; then ecmd="$ecmd --encrypt-threads=$encrypt_threads" fi if [ -n "$encrypt_chunk" ]; then ecmd="$ecmd --encrypt-chunk-size=$encrypt_chunk" fi else wsrep_log_error "Unknown encryption format='$eformat'" exit 2 fi [ "$WSREP_SST_OPT_ROLE" = 'joiner' ] && ecmd="$ecmd -d" stagemsg="$stagemsg-XB-Encrypted" } get_socat_ver() { [ -n "${SOCAT_VERSION+x}" ] && return # Determine the socat version SOCAT_VERSION=$(socat -V 2>&1 | \ grep -m1 -owE '[0-9]+(\.[0-9]+)+' | \ head -n1 || :) if [ -z "$SOCAT_VERSION" ]; then wsrep_log_error "******** FATAL ERROR ******************" wsrep_log_error "* Cannot determine the socat version. *" wsrep_log_error "***************************************" exit 2 fi } get_transfer() { if [ "$tfmt" = 'nc' ]; then wsrep_log_info "Using netcat as streamer" wsrep_check_programs nc tcmd='nc' if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then if nc -h 2>&1 | grep -q -F 'ncat'; then wsrep_log_info "Using Ncat as streamer" tcmd="$tcmd -l" elif nc -h 2>&1 | grep -qw -F -- '-d'; then wsrep_log_info "Using Debian netcat as streamer" tcmd="$tcmd -dl" if [ $WSREP_SST_OPT_HOST_IPv6 -eq 1 ]; then # When host is not explicitly specified (when only the port # is specified) netcat can only bind to an IPv4 address if # the "-6" option is not explicitly specified: tcmd="$tcmd -6" fi else wsrep_log_info "Using traditional netcat as streamer" tcmd="$tcmd -l -p" fi tcmd="$tcmd $SST_PORT" else # Check to see if netcat supports the '-N' flag. # -N Shutdown the network socket after EOF on stdin # If it supports the '-N' flag, then we need to use the '-N' # flag, otherwise the transfer will stay open after the file # transfer and cause the command to timeout. # Older versions of netcat did not need this flag and will # return an error if the flag is used. if nc -h 2>&1 | grep -qw -F -- '-N'; then tcmd="$tcmd -N" wsrep_log_info "Using nc -N" fi # netcat doesn't understand [] around IPv6 address if nc -h 2>&1 | grep -q -F 'ncat'; then wsrep_log_info "Using Ncat as streamer" elif nc -h 2>&1 | grep -qw -F -- '-d'; then wsrep_log_info "Using Debian netcat as streamer" else wsrep_log_info "Using traditional netcat as streamer" tcmd="$tcmd -q0" fi tcmd="$tcmd $WSREP_SST_OPT_HOST_UNESCAPED $SST_PORT" fi else tfmt='socat' wsrep_log_info "Using socat as streamer" wsrep_check_programs socat if [ -n "$sockopt" ]; then sockopt=$(trim_string "$sockopt" ',') if [ -n "$sockopt" ]; then sockopt=",$sockopt" fi fi # Add an option for ipv6 if needed: if [ $WSREP_SST_OPT_HOST_IPv6 -eq 1 ]; then # If sockopt contains 'pf=ip6' somewhere in the middle, # this will not interfere with socat, but exclude the trivial # cases when sockopt contains 'pf=ip6' as prefix or suffix: if [ "$sockopt" = "${sockopt#,pf=ip6,}" -a \ "$sockopt" = "${sockopt%,pf=ip6}" ] then sockopt=",pf=ip6$sockopt" fi fi if [ $encrypt -lt 2 ]; then if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then tcmd="socat -u TCP-LISTEN:$SST_PORT,reuseaddr$sockopt stdio" else tcmd="socat -u stdio TCP:$REMOTEIP:$SST_PORT$sockopt" fi return fi if ! socat -V | grep -q -F 'WITH_OPENSSL 1'; then wsrep_log_error "******** FATAL ERROR ************************************************ " wsrep_log_error "* Encryption requested, but socat is not OpenSSL enabled (encrypt=$encrypt) *" wsrep_log_error "********************************************************************* " exit 2 fi local action='Decrypting' if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then tcmd="socat -u openssl-listen:$SST_PORT,reuseaddr" else local addr="$REMOTEIP:$SST_PORT" tcmd="socat -u stdio openssl-connect:$addr" action='Encrypting' get_socat_ver if ! check_for_version "$SOCAT_VERSION" '1.7.4.1'; then if check_for_version "$SOCAT_VERSION" '1.7.3.3'; then # Workaround for a bug known as 'Red Hat issue 1870279' # (connection reset by peer) in socat versions 1.7.3.3 # to 1.7.4.0: tcmd="socat stdio openssl-connect:$addr,linger=10" wsrep_log_info \ "Use workaround for socat $SOCAT_VERSION bug" fi fi if check_for_version "$SOCAT_VERSION" '1.7.4'; then tcmd="$tcmd,no-sni=1" fi fi if [ "${sockopt#*,dhparam=}" = "$sockopt" ]; then if [ -z "$ssl_dhparams" ]; then get_socat_ver if ! check_for_version "$SOCAT_VERSION" '1.7.3'; then # socat versions < 1.7.3 will have 512-bit dhparams (too small) # so create 2048-bit dhparams and send that as a parameter: check_for_dhparams fi fi if [ -n "$ssl_dhparams" ]; then tcmd="$tcmd,dhparam='$ssl_dhparams'" fi fi CN_option=",commonname=''" if [ $encrypt -eq 2 ]; then wsrep_log_info \ "Using openssl based encryption with socat: with crt and pem" if [ -z "$tpem" -o -z "$tcert$tcap" ]; then wsrep_log_error \ "Both PEM file and CRT file (or path) are required" exit 22 fi verify_ca_matches_cert "$tpem" "$tcert" "$tcap" tcmd="$tcmd,cert='$tpem'" if [ -n "$tcert" ]; then tcmd="$tcmd,cafile='$tcert'" fi if [ -n "$tcap" ]; then tcmd="$tcmd,capath='$tcap'" fi stagemsg="$stagemsg-OpenSSL-Encrypted-2" wsrep_log_info "$action with cert='$tpem', ca='$tcert', capath='$tcap'" elif [ $encrypt -eq 3 -o $encrypt -eq 4 ]; then wsrep_log_info \ "Using openssl based encryption with socat: with key and crt" if [ -z "$tpem" -o -z "$tkey" ]; then wsrep_log_error "Both the certificate file (or path) and" \ "the key file are required" exit 22 fi verify_cert_matches_key "$tpem" "$tkey" stagemsg="$stagemsg-OpenSSL-Encrypted-3" if [ -z "$tcert$tcap" ]; then if [ $encrypt -eq 4 ]; then wsrep_log_error \ "Peer certificate file (or path) required if encrypt=4" exit 22 fi # no verification CN_option="" tcmd="$tcmd,cert='$tpem',key='$tkey',verify=0" wsrep_log_info \ "$action with cert='$tpem', key='$tkey', verify=0" else # CA verification verify_ca_matches_cert "$tpem" "$tcert" "$tcap" if [ -n "$WSREP_SST_OPT_REMOTE_USER" ]; then CN_option=",commonname='$WSREP_SST_OPT_REMOTE_USER'" elif [ "$WSREP_SST_OPT_ROLE" = 'joiner' -o $encrypt -eq 4 ] then CN_option=",commonname=''" elif is_local_ip "$WSREP_SST_OPT_HOST_UNESCAPED"; then CN_option=',commonname=localhost' else CN_option=",commonname='$WSREP_SST_OPT_HOST_UNESCAPED'" fi tcmd="$tcmd,cert='$tpem',key='$tkey'" if [ -n "$tcert" ]; then tcmd="$tcmd,cafile='$tcert'" fi if [ -n "$tcap" ]; then tcmd="$tcmd,capath='$tcap'" fi wsrep_log_info "$action with cert='$tpem', key='$tkey'," \ "ca='$tcert', capath='$tcap'" fi else wsrep_log_info "Unknown encryption mode: encrypt=$encrypt" exit 22 fi tcmd="$tcmd$CN_option$sockopt" if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then tcmd="$tcmd stdio" fi fi } get_footprint() { cd "$DATA_DIR" local payload_data if [ "$OS" = 'Linux' ]; then payload_data=$(find $findopt . \ -regex '.*undo[0-9]+$\|.*\.ibd$\|.*\.MYI$\|.*\.MYD$\|.*ibdata1$' \ -type f -print0 | du --files0-from=- --bytes -c -s | \ awk 'END { print $1 }') else payload_data=$(find $findopt . \ -regex '.*undo[0-9]+$|.*\.ibd$|.*\.MYI$\.*\.MYD$|.*ibdata1$' \ -type f -print0 | xargs -0 stat -f '%z' | \ awk '{ sum += $1 } END { print sum }') fi local payload_undo=0 if [ -n "$ib_undo_dir" -a "$ib_undo_dir" != '.' -a \ "$ib_undo_dir" != "$DATA_DIR" -a -d "$ib_undo_dir" ] then cd "$ib_undo_dir" if [ "$OS" = 'Linux' ]; then payload_undo=$(find . -regex '.*undo[0-9]+$' -type f -print0 | \ du --files0-from=- --bytes -c -s | awk 'END { print $1 }') else payload_undo=$(find . -regex '.*undo[0-9]+$' -type f -print0 | \ xargs -0 stat -f '%z' | awk '{ sum += $1 } END { print sum }') fi fi cd "$OLD_PWD" wsrep_log_info \ "SST footprint estimate: data: $payload_data, undo: $payload_undo" payload=$(( payload_data+payload_undo )) if [ "$compress" != 'none' ]; then # QuickLZ has around 50% compression ratio # When compression/compaction used, the progress is only an approximate. payload=$(( payload*1/2 )) fi if [ $WSREP_SST_OPT_PROGRESS -eq 1 ]; then # report to parent the total footprint of the SST echo "$TOTAL_TAG $payload" fi adjust_progress } adjust_progress() { pcmd="" rcmd="" [ "$progress" = 'none' ] && return rlimitopts="" if [ -n "$rlimit" -a "$WSREP_SST_OPT_ROLE" = 'donor' ]; then wsrep_log_info "Rate-limiting SST to $rlimit" rlimitopts=" -L $rlimit" fi if [ -n "$progress" ]; then # Backward compatibility: user-configured progress output pcmd="pv $pvopts$rlimitopts" if [ -z "${PV_FORMAT+x}" ]; then PV_FORMAT=0 pv --help | grep -qw -F -- '-F' && PV_FORMAT=1 fi if [ $PV_FORMAT -eq 1 ]; then pcmd="$pcmd $pvformat" fi if [ $payload -ne 0 ]; then pcmd="$pcmd -s $payload" fi if [ "$progress" != '1' ]; then if [ -e "$progress" ]; then pcmd="$pcmd 2>>'$progress'" else pcmd="$pcmd 2>'$progress'" fi fi elif [ $WSREP_SST_OPT_PROGRESS -eq 1 ]; then # Default progress output parseable by parent pcmd="pv -f -i 1 -n -b$rlimitopts" # read progress data, add tag and post to stdout # for the parent rcmd="stdbuf -oL tr '\r' '\n' | xargs -n1 echo complete" elif [ -n "$rlimitopts" ]; then # Rate-limiting only, when rlimit is non-zero pcmd="pv -q$rlimitopts" fi } bkgroups='sst|xtrabackup|mariabackup' encgroups="--mysqld|$bkgroups" read_cnf() { sfmt=$(parse_cnf sst streamfmt 'mbstream') tfmt=$(parse_cnf sst transferfmt 'socat') encrypt=$(parse_cnf "$encgroups" 'encrypt' 0) tmode=$(parse_cnf "$encgroups" 'ssl-mode' 'DISABLED' | \ tr '[[:lower:]]' '[[:upper:]]') case "$tmode" in 'VERIFY_IDENTITY'|'VERIFY_CA'|'REQUIRED'|'DISABLED') ;; *) wsrep_log_error "Unrecognized ssl-mode option: '$tmode'" exit 22 # EINVAL ;; esac if [ $encrypt -eq 0 -o $encrypt -ge 2 ]; then if [ "$tmode" != 'DISABLED' -o $encrypt -ge 2 ]; then check_server_ssl_config fi if [ "$tmode" != 'DISABLED' ]; then if [ 0 -eq $encrypt -a -n "$tpem" -a -n "$tkey" ] then encrypt=3 # enable cert/key SSL encyption # avoid CA verification if not set explicitly: # nodes may happen to have different CA if self-generated, # zeroing up tcert and tcap does the trick: if [ "${tmode#VERIFY}" = "$tmode" ]; then tcert="" tcap="" fi fi fi elif [ $encrypt -eq 1 ]; then ealgo=$(parse_cnf "$encgroups" 'encrypt-algo') eformat=$(parse_cnf "$encgroups" 'encrypt-format' 'openssl') ekey=$(parse_cnf "$encgroups" 'encrypt-key') # The keyfile should be read only when the key # is not specified or empty: if [ -z "$ekey" ]; then ekeyfile=$(parse_cnf "$encgroups" 'encrypt-key-file') fi fi wsrep_log_info "SSL configuration: CA='$tcert', CAPATH='$tcap'," \ "CERT='$tpem', KEY='$tkey', MODE='$tmode'," \ "encrypt='$encrypt'" if [ $encrypt -ge 2 ]; then ssl_dhparams=$(parse_cnf "$encgroups" 'ssl-dhparams') fi sockopt=$(parse_cnf sst sockopt) progress=$(parse_cnf sst progress) ttime=$(parse_cnf sst time 0) cpat='.*\.pem$\|.*galera\.cache$\|.*sst_in_progress$\|.*\.sst$\|.*gvwstate\.dat$\|.*grastate\.dat$\|.*\.err$\|.*\.log$\|.*RPM_UPGRADE_MARKER$\|.*RPM_UPGRADE_HISTORY$' [ "$OS" = 'FreeBSD' ] && cpat=$(echo "$cpat" | sed 's/\\|/|/g') cpat=$(parse_cnf sst cpat "$cpat") scomp=$(parse_cnf sst compressor) sdecomp=$(parse_cnf sst decompressor) rlimit=$(parse_cnf sst rlimit) uextra=$(parse_cnf sst use-extra 0) speciald=$(parse_cnf sst 'sst-special-dirs' 1) iopts=$(parse_cnf "$bkgroups" 'inno-backup-opts') iapts=$(parse_cnf "$bkgroups" 'inno-apply-opts') impts=$(parse_cnf "$bkgroups" 'inno-move-opts') use_memory=$(parse_cnf "$bkgroups" 'use-memory') if [ -z "$use_memory" ]; then if [ -n "$INNODB_BUFFER_POOL_SIZE" ]; then use_memory="$INNODB_BUFFER_POOL_SIZE" else use_memory=$(parse_cnf '--mysqld' 'innodb-buffer-pool-size') fi fi stimeout=$(parse_cnf sst 'sst-initial-timeout' 300) ssyslog=$(parse_cnf sst 'sst-syslog' 0) ssystag=$(parse_cnf mysqld_safe 'syslog-tag' "${SST_SYSLOG_TAG:-}") ssystag="$ssystag-" sstlogarchive=$(parse_cnf sst 'sst-log-archive' 1) sstlogarchivedir="" if [ $sstlogarchive -ne 0 ]; then sstlogarchivedir=$(parse_cnf sst sst-log-archive-dir \ '/tmp/sst_log_archive') if [ -n "$sstlogarchivedir" ]; then sstlogarchivedir=$(trim_dir "$sstlogarchivedir") fi fi if [ $speciald -eq 0 ]; then wsrep_log_error \ "sst-special-dirs equal to 0 is not supported, falling back to 1" speciald=1 fi if [ $ssyslog -ne -1 ]; then ssyslog=$(in_config 'mysqld_safe' 'syslog') fi if [ "$WSREP_SST_OPT_ROLE" = 'donor' ]; then compress=$(parse_cnf "$encgroups" 'compress' 'none') if [ "$compress" != 'none' ]; then compress_chunk=$(parse_cnf "$encgroups" 'compress-chunk-size') compress_threads=$(parse_cnf "$encgroups" 'compress-threads') fi fi backup_threads=$(parse_cnf "$encgroups" 'backup-threads') if [ "$eformat" = 'xbcrypt' ]; then encrypt_threads=$(parse_cnf "$encgroups" 'encrypt-threads') encrypt_chunk=$(parse_cnf "$encgroups" 'encrypt-chunk-size') fi } get_stream() { if [ "$sfmt" = 'mbstream' -o "$sfmt" = 'xbstream' ]; then sfmt='mbstream' local STREAM_BIN=$(commandex "$sfmt") if [ -z "$STREAM_BIN" ]; then wsrep_log_error "Streaming with $sfmt, but $sfmt not found in path" exit 42 fi if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then strmcmd="'$STREAM_BIN' -x" else strmcmd="'$STREAM_BIN' -c '$INFO_FILE' '$DONOR_INFO_FILE'" fi else sfmt='tar' if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then strmcmd='tar xfi -' else strmcmd="tar cf - '$INFO_FILE' '$DONOR_INFO_FILE'" fi fi wsrep_log_info "Streaming with $sfmt" } cleanup_at_exit() { # Since this is invoked just after exit NNN local estatus=$? if [ $estatus -ne 0 ]; then wsrep_log_error "Cleanup after exit with status: $estatus" elif [ -z "${coords:-}" -a "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then estatus=32 wsrep_log_error "Failed to get current position" fi [ "$(pwd)" != "$OLD_PWD" ] && cd "$OLD_PWD" if [ "$WSREP_SST_OPT_ROLE" = 'donor' -o $estatus -ne 0 ]; then if [ $estatus -ne 0 ]; then wsrep_log_error "Removing $MAGIC_FILE file due to signal" fi [ -f "$MAGIC_FILE" ] && rm -f "$MAGIC_FILE" || : [ -f "$DONOR_MAGIC_FILE" ] && rm -f "$DONOR_MAGIC_FILE" || : [ -f "$DATA/$IST_FILE" ] && rm -f "$DATA/$IST_FILE" || : fi if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then if [ -n "$BACKUP_PID" ]; then if ps -p $BACKUP_PID >/dev/null 2>&1; then wsrep_log_error \ "SST streaming process is still running. Killing..." cleanup_pid $BACKUP_PID fi fi wsrep_log_info "Removing the sst_in_progress file" wsrep_cleanup_progress_file fi if [ -n "$progress" -a -p "$progress" ]; then wsrep_log_info "Cleaning up fifo file: $progress" rm -f "$progress" || : fi wsrep_log_info "Cleaning up temporary directories" if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then [ -n "$STATDIR" -a -d "$STATDIR" ] && rm -rf "$STATDIR" || : else [ -n "$xtmpdir" -a -d "$xtmpdir" ] && rm -rf "$xtmpdir" || : [ -n "$itmpdir" -a -d "$itmpdir" ] && rm -rf "$itmpdir" || : fi # Final cleanup local pgid=$(ps -o 'pgid=' $$ 2>/dev/null | grep -o -E '[0-9]+' || :) # This means no setsid done in mysqld. # We don't want to kill mysqld here otherwise. if [ -n "$pgid" ]; then if [ $$ -eq $pgid ]; then # This means a signal was delivered to the process. # So, more cleanup. if [ $estatus -ge 128 ]; then kill -KILL -- -$$ || : fi fi fi if [ -n "$SST_PID" ]; then [ -f "$SST_PID" ] && rm -f "$SST_PID" || : fi exit $estatus } setup_ports() { SST_PORT="$WSREP_SST_OPT_PORT" if [ "$WSREP_SST_OPT_ROLE" = 'donor' ]; then REMOTEIP="$WSREP_SST_OPT_HOST" lsn="$WSREP_SST_OPT_LSN" sst_ver="$WSREP_SST_OPT_SST_VER" fi } # # Waits ~30 seconds for socat or nc to open the port and # then reports ready, regardless of timeout. # wait_for_listen() { for i in {1..150}; do if check_port "" "$SST_PORT" 'socat|nc|netcat'; then break fi sleep 0.2 done echo "ready $ADDR:$SST_PORT/$MODULE/$lsn/$sst_ver" } check_extra() { local use_socket=1 if [ $uextra -eq 1 ]; then local thread_handling=$(parse_cnf '--mysqld' 'thread-handling') if [ "$thread_handling" = 'pool-of-threads' ]; then local eport=$(parse_cnf '--mysqld' 'extra-port') if [ -n "$eport" ]; then # mariadb-backup works only locally. # Hence, setting host to 127.0.0.1 unconditionally: wsrep_log_info "SST through extra_port $eport" INNOEXTRA="$INNOEXTRA --host=127.0.0.1 --port=$eport" use_socket=0 else wsrep_log_error "Extra port $eport null, failing" exit 1 fi else wsrep_log_info "Thread pool not set, ignore the option use_extra" fi fi if [ $use_socket -eq 1 -a -n "$WSREP_SST_OPT_SOCKET" ]; then INNOEXTRA="$INNOEXTRA --socket='$WSREP_SST_OPT_SOCKET'" fi } recv_joiner() { local dir="$1" local msg="$2" local tmt=$3 local checkf=$4 local wait=$5 if [ ! -d "$dir" ]; then # This indicates that IST is in progress return fi local ltcmd="$tcmd" if [ $tmt -gt 0 ]; then if [ -n "$(commandex timeout)" ]; then local koption=0 if [ "$OS" = 'FreeBSD' -o "$OS" = 'NetBSD' -o "$OS" = 'OpenBSD' -o \ "$OS" = 'DragonFly' ]; then if timeout 2>&1 | grep -qw -F -- '-k'; then koption=1 fi else if timeout --help | grep -qw -F -- '-k'; then koption=1 fi fi if [ $koption -ne 0 ]; then ltcmd="timeout -k $(( tmt+10 )) $tmt $tcmd" else ltcmd="timeout -s 9 $tmt $tcmd" fi fi fi if [ $wait -ne 0 ]; then wait_for_listen & fi cd "$dir" set +e timeit "$msg" "$ltcmd | $strmcmd; RC=( "\${PIPESTATUS[@]}" )" set -e cd "$OLD_PWD" if [ ${RC[0]} -eq 124 ]; then wsrep_log_error "Possible timeout in receiving first data from" \ "donor in gtid stage: exit codes: ${RC[@]}" exit 32 fi for ecode in "${RC[@]}"; do if [ $ecode -ne 0 ]; then wsrep_log_error "Error while getting data from donor node:" \ "exit codes: ${RC[@]}" exit 32 fi done if [ $checkf -eq 1 ]; then if [ ! -r "$MAGIC_FILE" ]; then # this message should cause joiner to abort: wsrep_log_error "receiving process ended without creating" \ "magic file ($MAGIC_FILE)" wsrep_log_info "Contents of datadir:" wsrep_log_info "$(ls -l "$dir"/*)" exit 32 fi if [ -n "$MY_SECRET" ]; then # Check donor supplied secret: SECRET=$(grep -m1 -E "^$SECRET_TAG[[:space:]]" "$MAGIC_FILE" || :) SECRET=$(trim_string "${SECRET#$SECRET_TAG}") if [ "$SECRET" != "$MY_SECRET" ]; then wsrep_log_error "Donor does not know my secret!" wsrep_log_info "Donor: '$SECRET', my: '$MY_SECRET'" exit 32 fi fi if [ $WSREP_SST_OPT_PROGRESS -eq 1 ]; then # check total SST footprint payload=$(grep -m1 -E "^$TOTAL_TAG[[:space:]]" "$MAGIC_FILE" || :) if [ -n "$payload" ]; then payload=$(trim_string "${payload#$TOTAL_TAG}") if [ $payload -ge 0 ]; then # report to parent echo "$TOTAL_TAG $payload" fi fi fi fi } send_donor() { local dir="$1" local msg="$2" cd "$dir" set +e timeit "$msg" "$strmcmd | $tcmd; RC=( "\${PIPESTATUS[@]}" )" set -e cd "$OLD_PWD" for ecode in "${RC[@]}"; do if [ $ecode -ne 0 ]; then wsrep_log_error "Error while sending data to joiner node:" \ "exit codes: ${RC[@]}" exit 32 fi done } monitor_process() { local sst_stream_pid=$1 while :; do if ! ps -p $WSREP_SST_OPT_PARENT >/dev/null 2>&1; then wsrep_log_error \ "Parent mysqld process (PID: $WSREP_SST_OPT_PARENT)" \ "terminated unexpectedly." kill -- -$WSREP_SST_OPT_PARENT exit 32 fi if ! ps -p $sst_stream_pid >/dev/null 2>&1; then break fi sleep 0.1 done } read_cnf setup_ports if [ "$progress" = 'none' ]; then wsrep_log_info "All progress/rate-limiting disabled by configuration" elif [ -z "$(commandex pv)" ]; then wsrep_log_info "Progress reporting tool pv not found in path: $PATH" wsrep_log_info "Disabling all progress/rate-limiting" progress='none' fi if "$BACKUP_BIN" --help 2>/dev/null | grep -qw -F -- '--version-check'; then disver=' --no-version-check' fi get_stream get_transfer findopt='-L' [ "$OS" = 'FreeBSD' ] && findopt="$findopt -E" wait_previous_sst [ -f "$MAGIC_FILE" ] && rm -f "$MAGIC_FILE" [ -f "$DONOR_MAGIC_FILE" ] && rm -f "$DONOR_MAGIC_FILE" [ -f "$DATA/$IST_FILE" ] && rm -f "$DATA/$IST_FILE" if [ $ssyslog -eq 1 ]; then if [ -n "$(commandex logger)" ]; then wsrep_log_info "Logging all stderr of SST/mariadb-backup to syslog" exec 2> >(logger -p daemon.err -t ${ssystag}wsrep-sst-$WSREP_SST_OPT_ROLE) wsrep_log_error() { logger -p daemon.err -t ${ssystag}wsrep-sst-$WSREP_SST_OPT_ROLE -- "$@" } wsrep_log_warning() { logger -p daemon.warning -t ${ssystag}wsrep-sst-$WSREP_SST_OPT_ROLE -- "$@" } wsrep_log_info() { logger -p daemon.info -t ${ssystag}wsrep-sst-$WSREP_SST_OPT_ROLE -- "$@" } else wsrep_log_error "logger not in path: $PATH. Ignoring" fi INNOAPPLY="2>&1 | logger -p daemon.err -t ${ssystag}innobackupex-apply" INNOMOVE="2>&1 | logger -p daemon.err -t ${ssystag}innobackupex-move" INNOBACKUP="2> >(logger -p daemon.err -t ${ssystag}innobackupex-backup)" else if [ $sstlogarchive -eq 1 ] then ARCHIVETIMESTAMP=$(date '+%Y.%m.%d-%H.%M.%S.%N') if [ -n "$sstlogarchivedir" ]; then if [ ! -d "$sstlogarchivedir" ]; then if ! mkdir -p "$sstlogarchivedir"; then sstlogarchivedir="" wsrep_log_warning \ "Unable to create '$sstlogarchivedir' directory" fi elif [ ! -w "$sstlogarchivedir" ]; then sstlogarchivedir="" wsrep_log_warning \ "The '$sstlogarchivedir' directory is not writtable" fi fi if [ -e "$INNOAPPLYLOG" ]; then if [ -n "$sstlogarchivedir" ]; then newfile=$(basename "$INNOAPPLYLOG") newfile="$sstlogarchivedir/$newfile.$ARCHIVETIMESTAMP" else newfile="$INNOAPPLYLOG.$ARCHIVETIMESTAMP" fi wsrep_log_info "Moving '$INNOAPPLYLOG' to '$newfile'" mv "$INNOAPPLYLOG" "$newfile" && gzip "$newfile" || \ wsrep_log_warning "Failed to archive log file ('$newfile')" fi if [ -e "$INNOMOVELOG" ]; then if [ -n "$sstlogarchivedir" ]; then newfile=$(basename "$INNOMOVELOG") newfile="$sstlogarchivedir/$newfile.$ARCHIVETIMESTAMP" else newfile="$INNOMOVELOG.$ARCHIVETIMESTAMP" fi wsrep_log_info "Moving '$INNOMOVELOG' to '$newfile'" mv "$INNOMOVELOG" "$newfile" && gzip "$newfile" || \ wsrep_log_warning "Failed to archive log file ('$newfile')" fi if [ -e "$INNOBACKUPLOG" ]; then if [ -n "$sstlogarchivedir" ]; then newfile=$(basename "$INNOBACKUPLOG") newfile="$sstlogarchivedir/$newfile.$ARCHIVETIMESTAMP" else newfile="$INNOBACKUPLOG.$ARCHIVETIMESTAMP" fi wsrep_log_info "Moving '$INNOBACKUPLOG' to '$newfile'" mv "$INNOBACKUPLOG" "$newfile" && gzip "$newfile" || \ wsrep_log_warning "Failed to archive log file ('$newfile')" fi fi INNOAPPLY="> '$INNOAPPLYLOG' 2>&1" INNOMOVE="> '$INNOMOVELOG' 2>&1" INNOBACKUP="2> '$INNOBACKUPLOG'" fi setup_commands() { local mysqld_args="" if [ -n "$WSREP_SST_OPT_MYSQLD" ]; then mysqld_args=" --mysqld-args $WSREP_SST_OPT_MYSQLD" fi local recovery="" if [ -n "$INNODB_FORCE_RECOVERY" ]; then recovery=" --innodb-force-recovery=$INNODB_FORCE_RECOVERY" fi if [ -n "$use_memory" ]; then INNOEXTRA="$INNOEXTRA --use-memory=$use_memory" fi INNOAPPLY="$BACKUP_BIN --prepare$disver$recovery${iapts:+ }$iapts$INNOEXTRA --target-dir='$DATA' --datadir='$DATA'$mysqld_args $INNOAPPLY" INNOMOVE="$BACKUP_BIN$WSREP_SST_OPT_CONF --move-back$disver${impts:+ }$impts$INNOEXTRA --galera-info --force-non-empty-directories --target-dir='$DATA' --datadir='${TDATA:-$DATA}' $INNOMOVE" INNOBACKUP="$BACKUP_BIN$WSREP_SST_OPT_CONF --backup$disver${iopts:+ }$iopts$tmpopts$INNOEXTRA --galera-info --stream=$sfmt --target-dir='$itmpdir' --datadir='$DATA'$mysqld_args $INNOBACKUP" } send_magic() { # Store donor's wsrep GTID (state ID) and wsrep_gtid_domain_id # (separated by a space). echo "$WSREP_SST_OPT_GTID $WSREP_SST_OPT_GTID_DOMAIN_ID" > "$MAGIC_FILE" echo "$WSREP_SST_OPT_GTID $WSREP_SST_OPT_GTID_DOMAIN_ID" > "$DONOR_MAGIC_FILE" if [ -n "$WSREP_SST_OPT_REMOTE_PSWD" ]; then # Let joiner know that we know its secret echo "$SECRET_TAG $WSREP_SST_OPT_REMOTE_PSWD" >> "$MAGIC_FILE" fi if [ $WSREP_SST_OPT_BYPASS -eq 0 -a $WSREP_SST_OPT_PROGRESS -eq 1 ]; then # Tell joiner what to expect: echo "$TOTAL_TAG $payload" >> "$MAGIC_FILE" fi } if [ "$WSREP_SST_OPT_ROLE" = 'donor' ]; then trap cleanup_at_exit EXIT if [ $WSREP_SST_OPT_BYPASS -eq 0 ] then if [ -z "$sst_ver" ]; then wsrep_log_error "Upgrade joiner to 5.6.21 or higher for backup locks support" wsrep_log_error "The joiner is not supported for this version of donor" exit 93 fi tmpdir=$(parse_cnf "$encgroups" 'tmpdir') if [ -z "$tmpdir" ]; then xtmpdir="$(mktemp -d)" itmpdir="$(mktemp -d)" elif [ "$OS" = 'Linux' ]; then xtmpdir=$(mktemp -d "--tmpdir=$tmpdir") itmpdir=$(mktemp -d "--tmpdir=$tmpdir") else xtmpdir=$(TMPDIR="$tmpdir"; mktemp -d) itmpdir=$(TMPDIR="$tmpdir"; mktemp -d) fi wsrep_log_info "Using '$xtmpdir' as mariadb-backup temporary directory" tmpopts=" --tmpdir='$xtmpdir'" wsrep_log_info "Using '$itmpdir' as mariadb-backup working directory" if [ -n "$WSREP_SST_OPT_USER" ]; then INNOEXTRA="$INNOEXTRA --user='$WSREP_SST_OPT_USER'" fi if [ -n "$WSREP_SST_OPT_PSWD" ]; then export MYSQL_PWD="$WSREP_SST_OPT_PSWD" elif [ -n "$WSREP_SST_OPT_USER" ]; then # Empty password, used for testing, debugging etc. unset MYSQL_PWD fi check_extra if [ -n "$progress" -o $WSREP_SST_OPT_PROGRESS -eq 1 ]; then wsrep_log_info "Estimating total transfer size" get_footprint wsrep_log_info "To transfer: $payload" else adjust_progress fi wsrep_log_info "Streaming GTID file before SST" send_magic ttcmd="$tcmd" if [ -n "$scomp" ]; then tcmd="$scomp | $tcmd" fi get_keys if [ $encrypt -eq 1 ]; then tcmd="$ecmd | $tcmd" fi send_donor "$DATA" "$stagemsg-gtid" # Restore the transport commmand to its original state tcmd="$ttcmd" if [ -n "$pcmd" ]; then if [ -n "$rcmd" ]; then # redirect pv stderr to rcmd for tagging and output to parent tcmd="{ $pcmd 2>&3 | $tcmd; } 3>&1 | $rcmd" else # use user-configured pv output tcmd="$pcmd | $tcmd" fi fi wsrep_log_info "Sleeping before data transfer for SST" sleep 10 wsrep_log_info "Streaming the backup to joiner at $REMOTEIP:$SST_PORT" # Add compression to the head of the stream (if specified) if [ -n "$scomp" ]; then tcmd="$scomp | $tcmd" fi # Add encryption to the head of the stream (if specified) if [ $encrypt -eq 1 ]; then tcmd="$ecmd | $tcmd" fi iopts="--databases-exclude='lost+found'${iopts:+ }$iopts" if [ ${FORCE_FTWRL:-0} -eq 1 ]; then wsrep_log_info "Forcing FTWRL due to environment variable" \ "FORCE_FTWRL equal to $FORCE_FTWRL" iopts="--no-backup-locks${iopts:+ }$iopts" fi # if compression is enabled for backup files, then add the # appropriate options to the mariadb-backup command line: if [ "$compress" != 'none' ]; then iopts="--compress${compress:+=$compress}${iopts:+ }$iopts" if [ -n "$compress_threads" ]; then iopts="--compress-threads=$compress_threads${iopts:+ }$iopts" fi if [ -n "$compress_chunk" ]; then iopts="--compress-chunk-size=$compress_chunk${iopts:+ }$iopts" fi fi if [ -n "$backup_threads" ]; then iopts="--parallel=$backup_threads${iopts:+ }$iopts" fi setup_commands set +e timeit "$stagemsg-SST" "$INNOBACKUP | $tcmd; RC=( "\${PIPESTATUS[@]}" )" set -e if [ ${RC[0]} -ne 0 ]; then wsrep_log_error "mariadb-backup finished with error: ${RC[0]}." \ "Check syslog or '$INNOBACKUPLOG' for details" exit 22 elif [ ${RC[$(( ${#RC[@]}-1 ))]} -eq 1 ]; then wsrep_log_error "$tcmd finished with error: ${RC[1]}" exit 22 fi else # BYPASS FOR IST wsrep_log_info "Bypassing the SST for IST" echo 'continue' # now server can resume updating data send_magic echo '1' > "$DATA/$IST_FILE" if [ -n "$scomp" ]; then tcmd="$scomp | $tcmd" fi get_keys if [ $encrypt -eq 1 ]; then tcmd="$ecmd | $tcmd" fi strmcmd="$strmcmd '$IST_FILE'" send_donor "$DATA" "$stagemsg-IST" fi echo "done $WSREP_SST_OPT_GTID" wsrep_log_info "Total time on donor: $totime seconds" else # joiner create_dirs 1 [ -e "$SST_PROGRESS_FILE" ] && \ wsrep_log_info "Stale sst_in_progress file: $SST_PROGRESS_FILE" [ -n "$SST_PROGRESS_FILE" ] && touch "$SST_PROGRESS_FILE" if [ -n "$backup_threads" ]; then impts="--parallel=$backup_threads${impts:+ }$impts" fi stagemsg='Joiner-Recv' MODULE="${WSREP_SST_OPT_MODULE:-xtrabackup_sst}" ADDR="$WSREP_SST_OPT_HOST" if [ "${tmode#VERIFY}" != "$tmode" ]; then # backward-incompatible behavior: CN="" if [ -n "$tpem" ]; then CN=$(openssl_getCN "$tpem") fi MY_SECRET="$(wsrep_gen_secret)" # Add authentication data to address ADDR="$CN:$MY_SECRET@$ADDR" else MY_SECRET="" # for check down in recv_joiner() fi get_keys if [ $encrypt -eq 1 ]; then strmcmd="$ecmd | $strmcmd" fi if [ -n "$sdecomp" ]; then strmcmd="$sdecomp | $strmcmd" fi check_sockets_utils trap cleanup_at_exit EXIT STATDIR="$(mktemp -d)" MAGIC_FILE="$STATDIR/$INFO_FILE" DONOR_MAGIC_FILE="$STATDIR/$DONOR_INFO_FILE" recv_joiner "$STATDIR" "$stagemsg-gtid" $stimeout 1 1 if ! ps -p "$WSREP_SST_OPT_PARENT" >/dev/null 2>&1; then wsrep_log_error "Parent mysqld process (PID: $WSREP_SST_OPT_PARENT)" \ "terminated unexpectedly." exit 32 fi if [ ! -r "$STATDIR/$IST_FILE" ]; then adjust_progress if [ -n "$pcmd" ]; then if [ -n "$rcmd" ]; then # redirect pv stderr to rcmd for tagging and output to parent strmcmd="{ $pcmd 2>&3 | $strmcmd; } 3>&1 | $rcmd" else # use user-configured pv output strmcmd="$pcmd | $strmcmd" fi fi if [ -d "$DATA/.sst" ]; then wsrep_log_info \ "WARNING: Stale temporary SST directory:" \ "'$DATA/.sst' from previous state transfer, removing..." rm -rf "$DATA/.sst" fi mkdir -p "$DATA/.sst" (recv_joiner "$DATA/.sst" "$stagemsg-SST" 0 0 0) & BACKUP_PID=$! wsrep_log_info "Proceeding with SST" get_binlog if [ -n "$WSREP_SST_OPT_BINLOG" ]; then binlog_dir=$(dirname "$WSREP_SST_OPT_BINLOG") binlog_base=$(basename "$WSREP_SST_OPT_BINLOG") binlog_index="$WSREP_SST_OPT_BINLOG_INDEX" cd "$DATA" wsrep_log_info "Cleaning the old binary logs" # If there is a file with binlogs state, delete it: [ -f "$binlog_base.state" ] && rm "$binlog_base.state" >&2 # Clean up the old binlog files and index: if [ -f "$binlog_index" ]; then while read bin_file || [ -n "$bin_file" ]; do rm -f "$bin_file" >&2 || : done < "$binlog_index" rm "$binlog_index" >&2 fi if [ -n "$binlog_dir" -a "$binlog_dir" != '.' -a \ -d "$binlog_dir" ] then cd "$binlog_dir" if [ "$(pwd)" != "$DATA_DIR" ]; then wsrep_log_info \ "Cleaning the binlog directory '$binlog_dir' as well" fi fi rm -f "$binlog_base".[0-9]* >&2 || : cd "$OLD_PWD" fi wsrep_log_info \ "Cleaning the existing datadir and innodb-data/log directories" find $findopt ${ib_home_dir:+"$ib_home_dir"} \ ${ib_undo_dir:+"$ib_undo_dir"} \ ${ib_log_dir:+"$ib_log_dir"} \ ${ar_log_dir:+"$ar_log_dir"} \ "$DATA" -mindepth 1 -prune -regex "$cpat" \ -o -exec rm -rf {} >&2 \+ # Deleting files from previous SST and legacy files from old versions: [ -f "$DATA/xtrabackup_binary" ] && rm -f "$DATA/xtrabackup_binary" [ -f "$DATA/xtrabackup_pid" ] && rm -f "$DATA/xtrabackup_pid" [ -f "$DATA/xtrabackup_checkpoints" ] && rm -f "$DATA/xtrabackup_checkpoints" [ -f "$DATA/xtrabackup_info" ] && rm -f "$DATA/xtrabackup_info" [ -f "$DATA/xtrabackup_slave_info" ] && rm -f "$DATA/xtrabackup_slave_info" [ -f "$DATA/xtrabackup_binlog_info" ] && rm -f "$DATA/xtrabackup_binlog_info" [ -f "$DATA/xtrabackup_binlog_pos_innodb" ] && rm -f "$DATA/xtrabackup_binlog_pos_innodb" TDATA="$DATA" DATA="$DATA/.sst" MAGIC_FILE="$DATA/$INFO_FILE" wsrep_log_info "Waiting for SST streaming to complete!" monitor_process $BACKUP_PID BACKUP_PID="" if [ ! -s "$DATA/xtrabackup_checkpoints" ]; then wsrep_log_error "xtrabackup_checkpoints missing," \ "failed mariadb-backup/SST on donor" exit 2 fi # Compact backups are not supported by mariadb-backup if grep -qw -F 'compact = 1' "$DATA/xtrabackup_checkpoints"; then wsrep_log_info "Index compaction detected" wsrep_log_error "Compact backups are not supported by mariadb-backup" exit 2 fi qpfiles=$(find $findopt "$DATA" -maxdepth 1 -type f -name '*.qp' -print -quit) if [ -n "$qpfiles" ]; then wsrep_log_info "Compressed qpress files found" if [ -z "$(commandex qpress)" ]; then wsrep_log_error "qpress utility not found in the path" exit 22 fi get_proc dcmd="xargs -n 2 qpress -dT$nproc" if [ -n "$progress" -a "$progress" != 'none' ] && \ pv --help | grep -qw -F -- '--line-mode' then count=$(find $findopt "$DATA" -maxdepth 1 -type f -name '*.qp' | wc -l) count=$(( count*2 )) pvopts='-f -l -N Decompression' pvformat="-F '%N => Rate:%r Elapsed:%t %e Progress: [%b/$count]'" payload=$count adjust_progress dcmd="$pcmd | $dcmd" fi # Decompress the qpress files wsrep_log_info "Decompression with $nproc threads" timeit 'Joiner-Decompression' \ "find $findopt '$DATA' -type f -name '*.qp' -printf '%p\n%h\n' | \ $dcmd" extcode=$? if [ $extcode -eq 0 ]; then wsrep_log_info "Removing qpress files after decompression" find $findopt "$DATA" -type f -name '*.qp' -delete if [ $? -ne 0 ]; then wsrep_log_error \ "Something went wrong with deletion of qpress files." \ "Investigate" fi else wsrep_log_error "Decompression failed. Exit code: $extcode" exit 22 fi fi wsrep_log_info "Preparing the backup at $DATA" setup_commands timeit 'mariadb-backup prepare stage' "$INNOAPPLY" if [ $? -ne 0 ]; then wsrep_log_error "mariadb-backup apply finished with errors." \ "Check syslog or '$INNOAPPLYLOG' for details." exit 22 fi if [ -n "$WSREP_SST_OPT_BINLOG" ]; then cd "$DATA" binlogs="" if [ -f 'xtrabackup_binlog_info' ]; then NL=$'\n' while read bin_string || [ -n "$bin_string" ]; do bin_file=$(echo "$bin_string" | cut -f1) if [ -f "$bin_file" ]; then binlogs="$binlogs${binlogs:+$NL}$bin_file" fi done < 'xtrabackup_binlog_info' else binlogs=$(ls -d -1 "$binlog_base".[0-9]* 2>/dev/null || :) fi cd "$DATA_DIR" if [ -n "$binlog_dir" -a "$binlog_dir" != '.' -a \ "$binlog_dir" != "$DATA_DIR" ] then [ ! -d "$binlog_dir" ] && mkdir -p "$binlog_dir" fi index_dir=$(dirname "$binlog_index"); if [ -n "$index_dir" -a "$index_dir" != '.' -a \ "$index_dir" != "$DATA_DIR" ] then [ ! -d "$index_dir" ] && mkdir -p "$index_dir" fi if [ -n "$binlogs" ]; then wsrep_log_info "Moving binary logs to $binlog_dir" echo "$binlogs" | \ while read bin_file || [ -n "$bin_file" ]; do mv "$DATA/$bin_file" "$binlog_dir" echo "$binlog_dir${binlog_dir:+/}$bin_file" >> "$binlog_index" done fi cd "$OLD_PWD" fi MAGIC_FILE="$TDATA/$INFO_FILE" DONOR_MAGIC_FILE="$TDATA/$DONOR_INFO_FILE" wsrep_log_info "Moving the backup to $TDATA" timeit 'mariadb-backup move stage' "$INNOMOVE" if [ $? -eq 0 ]; then wsrep_log_info "Move successful, removing $DATA" rm -rf "$DATA" DATA="$TDATA" else wsrep_log_error "Move failed, keeping '$DATA' for further diagnosis" wsrep_log_error "Check syslog or '$INNOMOVELOG' for details" exit 22 fi else wsrep_log_info "'$IST_FILE' received from donor: Running IST" if [ $WSREP_SST_OPT_BYPASS -eq 0 ]; then readonly WSREP_SST_OPT_BYPASS=1 readonly WSREP_TRANSFER_TYPE='IST' fi fi if [ ! -r "$MAGIC_FILE" ]; then wsrep_log_error "Internal error: SST magic file '$MAGIC_FILE'" \ "not found or not readable" exit 2 fi simulate_long_sst # use donor magic file, if present # if IST was used, donor magic file was not created # Remove special tags from the magic file, and from the output: if [ -r "$DONOR_MAGIC_FILE" ]; then coords=$(head -n1 "$DONOR_MAGIC_FILE") wsrep_log_info "Galera co-ords from donor: $coords" else coords=$(head -n1 "$MAGIC_FILE") wsrep_log_info "Galera co-ords from recovery: $coords" fi echo "$coords" # Output : UUID:seqno wsrep_gtid_domain_id wsrep_log_info "Total time on joiner: $totime seconds" fi wsrep_log_info "$WSREP_METHOD $WSREP_TRANSFER_TYPE completed on $WSREP_SST_OPT_ROLE" exit 0
[+]
..
[-] pip3.9
[edit]
[-] newgidmap
[edit]
[-] forever
[edit]
[-] sg_zone
[edit]
[-] gml2gv
[edit]
[-] stream
[edit]
[-] which
[edit]
[-] gpgparsemail
[edit]
[-] delv
[edit]
[-] mdb_copy
[edit]
[-] doveadm
[edit]
[-] msgcmp
[edit]
[-] rview
[edit]
[-] mailx.s-nail
[edit]
[-] mysqlimport
[edit]
[-] krb5-config
[edit]
[-] rpmdb
[edit]
[-] wc
[edit]
[-] find-repos-of-install
[edit]
[-] hb-ot-shape-closure
[edit]
[-] gcc-ranlib
[edit]
[-] gpg-error-config
[edit]
[-] cmsutil
[edit]
[-] myisampack
[edit]
[-] dpkg-split
[edit]
[-] powernow-k8-decode
[edit]
[-] semodule_expand
[edit]
[-] sieve-test
[edit]
[-] ea-php81-pecl
[edit]
[-] msgmerge
[edit]
[-] ping
[edit]
[-] gdbus-codegen
[edit]
[-] tload
[edit]
[-] ldd
[edit]
[-] nl-class-add
[edit]
[-] dumpkeys
[edit]
[-] whoami
[edit]
[-] nl-class-list
[edit]
[-] galera_new_cluster
[edit]
[-] msgunfmt
[edit]
[-] wmf2svg
[edit]
[-] systemd-inhibit
[edit]
[-] autoheader
[edit]
[-] seq
[edit]
[-] sg_raw
[edit]
[-] ul
[edit]
[-] captoinfo
[edit]
[-] lsipc
[edit]
[-] tail
[edit]
[-] btattach
[edit]
[-] gneqn
[edit]
[-] nmtui-hostname
[edit]
[-] lastcomm
[edit]
[-] blkrawverify
[edit]
[-] command
[edit]
[-] sccmap
[edit]
[-] yes
[edit]
[-] dnf-3
[edit]
[-] sg_compare_and_write
[edit]
[-] neato
[edit]
[-] mysql_upgrade
[edit]
[-] sg_logs
[edit]
[-] sg_unmap
[edit]
[-] pkexec
[edit]
[-] grub2-mkpasswd-pbkdf2
[edit]
[-] mysql_plugin
[edit]
[-] pkttyagent
[edit]
[-] pkla-admin-identities
[edit]
[-] imunify-antivirus
[edit]
[-] login
[edit]
[-] aria_read_log
[edit]
[-] lsiio
[edit]
[-] pic
[edit]
[-] vlock
[edit]
[-] gslj
[edit]
[-] modulemd-validator
[edit]
[-] mandb
[edit]
[-] teamdctl
[edit]
[-] fg
[edit]
[-] mariadb-fix-extensions
[edit]
[-] defncopy
[edit]
[-] clear
[edit]
[-] sg
[edit]
[-] tac
[edit]
[-] dotty
[edit]
[-] gpio-watch
[edit]
[-] rpcinfo
[edit]
[-] update-crypto-policies
[edit]
[-] utmpdump
[edit]
[-] grub2-fstest
[edit]
[-] msgcomm
[edit]
[-] btmon
[edit]
[-] dnsdomainname
[edit]
[-] wireplumber
[edit]
[-] systemd-run
[edit]
[-] nl-neightbl-list
[edit]
[-] pydoc
[edit]
[-] zforce
[edit]
[-] sg_start
[edit]
[-] whiptail
[edit]
[-] expr
[edit]
[-] pipewire-aes67
[edit]
[-] bond2team
[edit]
[-] unxz
[edit]
[-] sg_seek
[edit]
[-] osinfo-detect
[edit]
[-] sg_persist
[edit]
[-] readlink
[edit]
[-] Mail
[edit]
[-] pipewire-pulse
[edit]
[-] printenv
[edit]
[-] mysql_secure_installation
[edit]
[-] lto-dump
[edit]
[-] grub2-mklayout
[edit]
[-] ssh-copy-id
[edit]
[-] hb-subset
[edit]
[-] links
[edit]
[-] gtk-update-icon-cache
[edit]
[-] mountpoint
[edit]
[-] sg_sat_set_features
[edit]
[-] xdg-dbus-proxy
[edit]
[-] grep
[edit]
[-] package-cleanup
[edit]
[-] hb-view
[edit]
[-] cmp
[edit]
[-] sg_safte
[edit]
[-] nl-link-list
[edit]
[-] ipcrm
[edit]
[-] ausyscall
[edit]
[-] resolveip
[edit]
[-] named-rrchecker
[edit]
[-] cpan
[edit]
[-] runcon
[edit]
[-] fprintd-delete
[edit]
[-] nl-route-list
[edit]
[-] dir
[edit]
[-] nisdomainname
[edit]
[-] gxl2dot
[edit]
[-] edgepaint
[edit]
[-] systemd-cat
[edit]
[-] rmdir
[edit]
[-] ps2pdf12
[edit]
[-] libtoolize
[edit]
[-] mysql_fix_extensions
[edit]
[-] nl-addr-add
[edit]
[-] mpstat
[edit]
[-] sg_read_attr
[edit]
[-] ptar
[edit]
[-] update-ca-trust
[edit]
[-] fc-cat
[edit]
[-] keyctl
[edit]
[-] nice
[edit]
[-] sqlite3
[edit]
[-] sg_sat_identify
[edit]
[-] chcat
[edit]
[-] sg_reassign
[edit]
[-] wsrep_sst_mariabackup
[edit]
[-] scp
[edit]
[-] lastlog
[edit]
[-] systemd-stdio-bridge
[edit]
[-] getkeycodes
[edit]
[-] osinfo-query
[edit]
[-] aria_dump_log
[edit]
[-] c++
[edit]
[-] nf-exp-add
[edit]
[-] xdg-email
[edit]
[-] aria_ftdump
[edit]
[-] signver
[edit]
[-] fc-cache
[edit]
[-] doveconf
[edit]
[-] ca-legacy
[edit]
[-] uapi
[edit]
[-] dpkg-divert
[edit]
[-] dwp
[edit]
[-] repotrack
[edit]
[-] page_owner_sort
[edit]
[-] echo
[edit]
[-] flatpak
[edit]
[-] git-upload-pack
[edit]
[-] slencheck
[edit]
[-] yumdownloader
[edit]
[-] pm2-docker
[edit]
[-] systemd-machine-id-setup
[edit]
[-] innochecksum
[edit]
[-] lsgpio
[edit]
[-] sha1sum
[edit]
[-] eject
[edit]
[-] grub2-mkimage
[edit]
[-] gsettings
[edit]
[-] myisamchk
[edit]
[-] imunify-agent-proxy
[edit]
[-] slabinfo
[edit]
[-] pk12util
[edit]
[-] setup-nsssysinit.sh
[edit]
[-] gpasswd
[edit]
[-] sgp_dd
[edit]
[-] simc_lsmplugin
[edit]
[-] pftp
[edit]
[-] msggrep
[edit]
[-] col
[edit]
[-] ea-php81-pear
[edit]
[-] composite
[edit]
[-] unshare
[edit]
[-] zcat
[edit]
[-] tic
[edit]
[-] php
[edit]
[-] gio-querymodules-64
[edit]
[-] trust
[edit]
[-] mkfontdir
[edit]
[-] nl-classid-lookup
[edit]
[-] identify
[edit]
[-] nss-policy-check
[edit]
[-] lsmem
[edit]
[-] html2text
[edit]
[-] rpmverify
[edit]
[-] unix2mac
[edit]
[-] wmf2fig
[edit]
[-] zipdetails
[edit]
[-] tapestat
[edit]
[-] reposync
[edit]
[-] perl5.32.1
[edit]
[-] piconv
[edit]
[-] gdk-pixbuf-query-loaders-64
[edit]
[-] scl
[edit]
[-] mpris-proxy
[edit]
[-] getfattr
[edit]
[-] bc
[edit]
[-] nf-queue
[edit]
[-] hostid
[edit]
[-] sg_read_buffer
[edit]
[-] write
[edit]
[-] zipnote
[edit]
[-] msgfilter
[edit]
[-] dbus-uuidgen
[edit]
[-] msguniq
[edit]
[-] xdg-icon-resource
[edit]
[-] sg_sat_read_gplog
[edit]
[-] linux32
[edit]
[-] gvpack
[edit]
[-] nmtui-connect
[edit]
[-] rpmquery
[edit]
[-] nl
[edit]
[-] gpg-card
[edit]
[-] psfgettable
[edit]
[-] fc-pattern
[edit]
[-] cal
[edit]
[-] blkparse
[edit]
[-] wsrep_sst_rsync
[edit]
[-] dijkstra
[edit]
[-] batch
[edit]
[-] arch
[edit]
[-] cpapi2
[edit]
[-] nl-class-delete
[edit]
[-] perlbug
[edit]
[-] view
[edit]
[-] cyrusbdb2current
[edit]
[-] gnroff
[edit]
[-] symlinks
[edit]
[-] systemd-detect-virt
[edit]
[-] zipcloak
[edit]
[-] mariadb-import
[edit]
[-] false
[edit]
[-] npx
[edit]
[-] sadf
[edit]
[-] aspell
[edit]
[-] vdoforcerebuild
[edit]
[-] systemd-id128
[edit]
[-] perlthanks
[edit]
[-] hostname
[edit]
[-] setfacl
[edit]
[-] chardetect
[edit]
[-] audit2allow
[edit]
[-] linux64
[edit]
[-] gettext.sh
[edit]
[-] journalctl
[edit]
[-] aria_chk
[edit]
[-] setsid
[edit]
[-] mysqlslap
[edit]
[-] quota
[edit]
[-] dtrace
[edit]
[-] ld.bfd
[edit]
[-] update-desktop-database
[edit]
[-] nf-ct-list
[edit]
[-] cxpm
[edit]
[-] usleep
[edit]
[-] ranlib
[edit]
[-] showkey
[edit]
[-] pydoc3
[edit]
[-] xdg-desktop-icon
[edit]
[-] recode-sr-latin
[edit]
[-] im360-k8s-syncer
[edit]
[-] spell
[edit]
[-] sftp
[edit]
[-] setkeycodes
[edit]
[-] gtk-launch
[edit]
[-] sg_timestamp
[edit]
[-] red
[edit]
[-] sg_ses_microcode
[edit]
[-] renew-dummy-cert
[edit]
[-] xgettext
[edit]
[-] bashbug-64
[edit]
[-] mariadb-tzinfo-to-sql
[edit]
[-] sha224sum
[edit]
[-] mount
[edit]
[-] pip-3.9
[edit]
[-] mac2unix
[edit]
[-] pcre-config
[edit]
[-] mariadb-plugin
[edit]
[-] nail
[edit]
[-] brotli
[edit]
[-] ea-php81
[edit]
[-] xzgrep
[edit]
[-] objdump
[edit]
[-] gv2gxl
[edit]
[-] nl-cls-list
[edit]
[-] pinfo
[edit]
[-] hunspell
[edit]
[-] sleep
[edit]
[-] zip
[edit]
[-] yum-debug-restore
[edit]
[-] jq
[edit]
[-] protoc-gen-c
[edit]
[-] gdbm_dump
[edit]
[-] chown
[edit]
[-] osinfo-db-validate
[edit]
[-] ima-setup
[edit]
[-] ptx
[edit]
[-] fc-match
[edit]
[-] soelim
[edit]
[-] repo-graph
[edit]
[-] size
[edit]
[-] scriptlive
[edit]
[-] nl-neigh-list
[edit]
[-] df
[edit]
[-] gcov
[edit]
[-] kernel-install
[edit]
[-] pango-list
[edit]
[-] sg_dd
[edit]
[-] setmetamode
[edit]
[-] envml
[edit]
[-] id
[edit]
[-] icu-config
[edit]
[-] ar
[edit]
[-] pl2pm
[edit]
[-] kbdinfo
[edit]
[-] lsblk
[edit]
[-] soelim.groff
[edit]
[-] notify-send
[edit]
[-] aclocal
[edit]
[-] sha256sum
[edit]
[-] mmdblookup
[edit]
[-] preconv
[edit]
[-] conjure
[edit]
[-] xzfgrep
[edit]
[-] systemd-firstboot
[edit]
[-] pngfix
[edit]
[-] p11-kit
[edit]
[-] mariadb-dump
[edit]
[-] yum-config-manager
[edit]
[-] garbd
[edit]
[-] aserver
[edit]
[-] odbc_config
[edit]
[-] python3
[edit]
[-] bg
[edit]
[-] catchsegv
[edit]
[-] elinks
[edit]
[-] zmore
[edit]
[-] xslt-config
[edit]
[-] type
[edit]
[-] lchfn
[edit]
[-] x86_64-redhat-linux-gcc
[edit]
[-] lwp-dump
[edit]
[-] uname
[edit]
[-] wall
[edit]
[-] sg_sync
[edit]
[-] bunzip2
[edit]
[-] lsscsi
[edit]
[-] factor
[edit]
[-] pango-view
[edit]
[-] strace-log-merge
[edit]
[-] pre-grohtml
[edit]
[-] glib-genmarshal
[edit]
[-] ghostscript
[edit]
[-] run-parts
[edit]
[-] bash
[edit]
[-] hostnamectl
[edit]
[-] isosize
[edit]
[-] tdspool
[edit]
[-] pphs
[edit]
[-] nl-qdisc-add
[edit]
[-] gdbus
[edit]
[-] appstream-util
[edit]
[-] kdumpctl
[edit]
[-] bwrap
[edit]
[-] busctl
[edit]
[-] rev
[edit]
[-] namei
[edit]
[-] btrecord
[edit]
[-] md5sum
[edit]
[-] dbus-monitor
[edit]
[-] sha224hmac
[edit]
[-] nmtui-edit
[edit]
[-] lexgrog
[edit]
[-] gdbm_load
[edit]
[-] verify_blkparse
[edit]
[-] yum
[edit]
[-] gvmap.sh
[edit]
[-] certutil
[edit]
[-] iusql
[edit]
[-] bluetoothctl
[edit]
[-] sg_get_config
[edit]
[-] mariadb-hotcopy
[edit]
[-] mariadb-waitpid
[edit]
[-] strip
[edit]
[-] systemd-umount
[edit]
[-] usb-devices
[edit]
[-] gs
[edit]
[-] resizecons
[edit]
[-] nl-route-delete
[edit]
[-] gpgsplit
[edit]
[-] python3-config
[edit]
[-] centrino-decode
[edit]
[-] mysql_find_rows
[edit]
[-] pure-pwconvert
[edit]
[-] mysql_embedded
[edit]
[-] sg_write_x
[edit]
[-] ptargrep
[edit]
[-] wget
[edit]
[-] tmpwatch
[edit]
[-] json_reformat
[edit]
[-] bzfgrep
[edit]
[-] mogrify
[edit]
[-] animate
[edit]
[-] unix2dos
[edit]
[-] rvi
[edit]
[-] w
[edit]
[-] nl-link-name2ifindex
[edit]
[-] getconf
[edit]
[-] gr2fonttest
[edit]
[-] truncate
[edit]
[-] repomanage
[edit]
[-] column
[edit]
[-] authselect
[edit]
[-] bzdiff
[edit]
[-] fuse2fs
[edit]
[-] nl-addr-list
[edit]
[-] nm
[edit]
[-] gencat
[edit]
[-] split
[edit]
[-] funzip
[edit]
[-] scriptreplay
[edit]
[-] gzip
[edit]
[-] msgfmt.py
[edit]
[-] gpgrt-config
[edit]
[-] mytop
[edit]
[-] ndptool
[edit]
[-] nl-nh-list
[edit]
[-] sg_bg_ctl
[edit]
[-] vdodumpconfig
[edit]
[-] psfstriptable
[edit]
[-] pm2-runtime
[edit]
[-] glib-mkenums
[edit]
[-] sg_test_rwbuf
[edit]
[-] unflatten
[edit]
[-] canberra-boot
[edit]
[-] checkpolicy
[edit]
[-] blkiomon
[edit]
[-] unzip
[edit]
[-] udevadm
[edit]
[-] sestatus
[edit]
[-] zone2sql
[edit]
[-] mdb_dump
[edit]
[-] clockdiff
[edit]
[-] import
[edit]
[-] linux-boot-prober
[edit]
[-] choom
[edit]
[-] sh
[edit]
[-] g++
[edit]
[-] ea-php84
[edit]
[-] plymouth
[edit]
[-] yat2m
[edit]
[-] info
[edit]
[-] sgm_dd
[edit]
[-] toe
[edit]
[-] zdump
[edit]
[-] appstream-compose
[edit]
[-] mariadb-find-rows
[edit]
[-] intel-speed-select
[edit]
[-] sievec
[edit]
[-] modutil
[edit]
[-] pm2
[edit]
[-] montage
[edit]
[-] dpkg-deb
[edit]
[-] libwmf-fontmap
[edit]
[-] sg_write_long
[edit]
[-] zdiff
[edit]
[-] vimtutor
[edit]
[-] grub2-syslinux2cfg
[edit]
[-] tmon
[edit]
[-] sg_write_buffer
[edit]
[-] dbus-update-activation-environment
[edit]
[-] python-config
[edit]
[-] pr
[edit]
[-] xsltproc
[edit]
[-] pkgconf
[edit]
[-] mysqlhotcopy
[edit]
[-] ps2pdf
[edit]
[-] update-mime-database
[edit]
[-] mariadb-binlog
[edit]
[-] acyclic
[edit]
[-] lwp-download
[edit]
[-] mysql_install_db
[edit]
[-] checkmodule
[edit]
[-] msginit
[edit]
[-] gslp
[edit]
[-] find
[edit]
[-] fincore
[edit]
[-] dirmngr
[edit]
[-] sha384hmac
[edit]
[-] file
[edit]
[-] automake-1.16
[edit]
[-] python3.9
[edit]
[-] pflags
[edit]
[-] grub2-mkrescue
[edit]
[-] blktrace
[edit]
[-] zfgrep
[edit]
[-] ea-php84-pecl
[edit]
[-] dbiprof
[edit]
[-] rnano
[edit]
[-] logname
[edit]
[-] mcookie
[edit]
[-] fips-mode-setup
[edit]
[-] mysql_convert_table_format
[edit]
[-] gcov-dump
[edit]
[-] libpng16-config
[edit]
[-] autoconf
[edit]
[-] ps2pdf14
[edit]
[-] bzgrep
[edit]
[-] flock
[edit]
[-] printafm
[edit]
[-] autoupdate
[edit]
[-] pm2-dev
[edit]
[-] cifsiostat
[edit]
[-] tee
[edit]
[-] python-html2text
[edit]
[-] wsrep_sst_mysqldump
[edit]
[-] sync
[edit]
[-] myisamlog
[edit]
[-] cksum
[edit]
[-] sudoreplay
[edit]
[-] rsvg-convert
[edit]
[-] gawk
[edit]
[-] systemd-repart
[edit]
[-] bzcat
[edit]
[-] unalias
[edit]
[-] users
[edit]
[-] systemd-tmpfiles
[edit]
[-] gcc-ar
[edit]
[-] nmcli
[edit]
[-] shuf
[edit]
[-] lastb
[edit]
[-] myisam_ftdump
[edit]
[-] sotruss
[edit]
[-] cpupower
[edit]
[-] aria_pack
[edit]
[-] encguess
[edit]
[-] pdf2ps
[edit]
[-] slabtop
[edit]
[-] libnetcfg
[edit]
[-] ld.gold
[edit]
[-] colcrt
[edit]
[-] xzcat
[edit]
[-] xzegrep
[edit]
[-] gpgv
[edit]
[-] man-recode
[edit]
[-] chfn
[edit]
[-] gcc
[edit]
[-] lesspipe.sh
[edit]
[-] lsphp
[edit]
[-] pf2afm
[edit]
[-] autom4te
[edit]
[-] freebcp
[edit]
[-] sg_map
[edit]
[-] grub2-glue-efi
[edit]
[-] traceroute
[edit]
[-] ps2pdf13
[edit]
[-] gtester
[edit]
[-] perl
[edit]
[-] prezip
[edit]
[-] cpansign
[edit]
[-] crc32
[edit]
[-] autoscan
[edit]
[-] pod2html
[edit]
[-] lslocks
[edit]
[-] grub2-render-label
[edit]
[-] free
[edit]
[-] unlink
[edit]
[-] msgconv
[edit]
[-] systemd-ask-password
[edit]
[-] sg_rdac
[edit]
[-] c89
[edit]
[-] podchecker
[edit]
[-] h2ph
[edit]
[-] catman
[edit]
[-] debuginfod-find
[edit]
[-] cc
[edit]
[-] mkfontscale
[edit]
[-] sss_ssh_knownhostsproxy
[edit]
[-] sprof
[edit]
[-] grub2-mknetdir
[edit]
[-] enc2xs
[edit]
[-] zone2json
[edit]
[-] unzipsfx
[edit]
[-] od
[edit]
[-] protoc
[edit]
[-] circo
[edit]
[-] dpkg-statoverride
[edit]
[-] ncat
[edit]
[-] freetype-config
[edit]
[-] mdb_load
[edit]
[-] nm-online
[edit]
[-] locate
[edit]
[-] hb-shape
[edit]
[-] make
[edit]
[-] cpan-mirrors
[edit]
[-] systemd-mount
[edit]
[-] flex++
[edit]
[-] mariadb
[edit]
[-] nano
[edit]
[-] osage
[edit]
[-] pathchk
[edit]
[-] install
[edit]
[-] look
[edit]
[-] grub2-script-check
[edit]
[-] systemctl
[edit]
[-] nf-exp-delete
[edit]
[-] systemd-dissect
[edit]
[-] time
[edit]
[-] mailx
[edit]
[-] taskset
[edit]
[-] renice
[edit]
[-] xsubpp
[edit]
[-] sg_vpd
[edit]
[-] mail
[edit]
[-] pipewire
[edit]
[-] isql
[edit]
[-] fc
[edit]
[-] semodule_unpackage
[edit]
[-] uniq
[edit]
[-] hexdump
[edit]
[-] eps2eps
[edit]
[-] tset
[edit]
[-] stat
[edit]
[-] nsenter
[edit]
[-] csplit
[edit]
[-] datacopy
[edit]
[-] sudo
[edit]
[-] systemd-escape
[edit]
[-] ssh-keygen
[edit]
[-] garb-systemd
[edit]
[-] gpgconf
[edit]
[-] nl-link-release
[edit]
[-] eqn
[edit]
[-] gc
[edit]
[-] sum
[edit]
[-] sss_ssh_authorizedkeys
[edit]
[-] firewall-cmd
[edit]
[-] icu-config-64
[edit]
[-] xzmore
[edit]
[-] genl-ctrl-list
[edit]
[-] nl-fib-lookup
[edit]
[-] splain
[edit]
[-] nl-list-caches
[edit]
[-] secon
[edit]
[-] sw-engine
[edit]
[-] flatpak-coredumpctl
[edit]
[-] mariadb-dumpslow
[edit]
[-] autoreconf
[edit]
[-] iptc
[edit]
[-] bison
[edit]
[-] mv
[edit]
[-] xxd
[edit]
[-] lsmd
[edit]
[-] x86_64-redhat-linux-gcc-11
[edit]
[-] icuinfo
[edit]
[-] sdiff
[edit]
[-] nohup
[edit]
[-] prune
[edit]
[-] cronnext
[edit]
[-] dc
[edit]
[-] umask
[edit]
[-] xdg-desktop-menu
[edit]
[-] usbhid-dump
[edit]
[-] sha512sum
[edit]
[-] chronyc
[edit]
[-] ulockmgr_server
[edit]
[-] systemd-sysext
[edit]
[-] gcov-tool
[edit]
[-] sg_ident
[edit]
[-] python
[edit]
[-] ssh-keyscan
[edit]
[-] pcre2-config
[edit]
[-] head
[edit]
[-] realpath
[edit]
[-] mariadbd-multi
[edit]
[-] infotocap
[edit]
[-] httxt2dbm
[edit]
[-] findmnt
[edit]
[-] nroff
[edit]
[-] chvt
[edit]
[-] tracepath
[edit]
[-] scsi_ready
[edit]
[-] setpriv
[edit]
[-] cpp
[edit]
[-] host
[edit]
[-] dconf
[edit]
[-] systemd-analyze
[edit]
[-] mysqlaccess
[edit]
[-] diff
[edit]
[-] lsusb
[edit]
[-] dnstap-read
[edit]
[-] coredumpctl
[edit]
[-] troff
[edit]
[-] groff
[edit]
[-] logger
[edit]
[-] gdk-pixbuf-thumbnailer
[edit]
[-] xdg-settings
[edit]
[-] pinky
[edit]
[-] imunify360-command-wrapper
[edit]
[-] ifnames
[edit]
[-] sg_rmsn
[edit]
[-] ea-wappspector
[edit]
[-] canberra-gtk-play
[edit]
[-] lsattr
[edit]
[-] nmtui
[edit]
[-] htdbm
[edit]
[-] sg_emc_trespass
[edit]
[-] fc-query
[edit]
[-] exiv2
[edit]
[-] neqn
[edit]
[-] i386
[edit]
[-] fdp
[edit]
[-] sort
[edit]
[-] fmt
[edit]
[-] gpg-connect-agent
[edit]
[-] team2bond
[edit]
[-] setfattr
[edit]
[-] fold
[edit]
[-] lex
[edit]
[-] firewall-offline-cmd
[edit]
[-] sha384sum
[edit]
[-] git
[edit]
[-] pygettext.py
[edit]
[-] newgrp
[edit]
[-] repodiff
[edit]
[-] man
[edit]
[-] pip3
[edit]
[-] yum-debug-dump
[edit]
[-] infocmp
[edit]
[-] scsi_stop
[edit]
[-] wpctl
[edit]
[-] bootctl
[edit]
[-] sg_decode_sense
[edit]
[-] unexpand
[edit]
[-] chattr
[edit]
[-] openssl
[edit]
[-] dpkg-realpath
[edit]
[-] tsql
[edit]
[-] loadunimap
[edit]
[-] gsdj500
[edit]
[-] strace
[edit]
[-] pango-segmentation
[edit]
[-] lsof
[edit]
[-] snice
[edit]
[-] bno_plot.py
[edit]
[-] ld
[edit]
[-] sha512hmac
[edit]
[-] ulimit
[edit]
[-] gettextize
[edit]
[-] aclocal-1.16
[edit]
[-] uptime
[edit]
[-] gpgme-json
[edit]
[-] pgrep
[edit]
[-] gpgv2
[edit]
[-] semodule_link
[edit]
[-] bzcmp
[edit]
[-] ps2ascii
[edit]
[-] nl-list-sockets
[edit]
[-] 2to3
[edit]
[-] pstree
[edit]
[-] repoquery
[edit]
[-] vimdot
[edit]
[-] flex
[edit]
[-] libpng-config
[edit]
[-] gpg2
[edit]
[-] scsi_temperature
[edit]
[-] mariadb-convert-table-format
[edit]
[-] hardlink
[edit]
[-] loginctl
[edit]
[-] dnf4
[edit]
[-] mysqld_safe
[edit]
[-] nl-link-set
[edit]
[-] mariadb-slap
[edit]
[-] dircolors
[edit]
[-] sieve-dump
[edit]
[-] corepack
[edit]
[-] galera_recovery
[edit]
[-] gst-stats-1.0
[edit]
[-] crlutil
[edit]
[-] strings
[edit]
[-] streamzip
[edit]
[-] sar
[edit]
[-] pygettext3.py
[edit]
[-] yum-builddep
[edit]
[-] crb
[edit]
[-] auvirt
[edit]
[-] gpgtar
[edit]
[-] uname26
[edit]
[-] mariadb-conv
[edit]
[-] yum-groups-manager
[edit]
[-] dmesg
[edit]
[-] mariadb-upgrade
[edit]
[-] nl-route-get
[edit]
[-] pkg-config
[edit]
[-] sg_map26
[edit]
[-] fgconsole
[edit]
[-] mariadbd-safe-helper
[edit]
[-] lesskey
[edit]
[-] ngettext
[edit]
[-] zless
[edit]
[-] ps2ps2
[edit]
[-] mysql_setpermission
[edit]
[-] chage
[edit]
[-] geqn
[edit]
[-] whatis.man-db
[edit]
[-] htpasswd
[edit]
[-] autopoint
[edit]
[-] cpio
[edit]
[-] json_xs
[edit]
[-] mysqldumpslow
[edit]
[-] scsi_start
[edit]
[-] base64
[edit]
[-] pkill
[edit]
[-] mkfifo
[edit]
[-] sxpm
[edit]
[-] convert
[edit]
[-] mysqld_multi
[edit]
[-] ps2pdfwr
[edit]
[-] pw-jack
[edit]
[-] sg_sat_phy_event
[edit]
[-] at
[edit]
[-] compile_et
[edit]
[-] tabs
[edit]
[-] mariadb-admin
[edit]
[-] watch
[edit]
[-] date
[edit]
[-] ipcmk
[edit]
[-] wpexec
[edit]
[-] gvcolor
[edit]
[-] psfxtable
[edit]
[-] pdnsutil
[edit]
[-] egrep
[edit]
[-] vimdiff
[edit]
[-] xmlcatalog
[edit]
[-] nl-link-ifindex2name
[edit]
[-] awk
[edit]
[-] numfmt
[edit]
[-] pyinotify
[edit]
[-] sg_stpg
[edit]
[-] l2ping
[edit]
[-] git-receive-pack
[edit]
[-] iconv
[edit]
[-] ssh-add
[edit]
[-] ed
[edit]
[-] lsns
[edit]
[-] scl_source
[edit]
[-] fc-validate
[edit]
[-] wsrep_sst_rsync_wan
[edit]
[-] chsh
[edit]
[-] procan
[edit]
[-] display
[edit]
[-] dpkg
[edit]
[-] pwmake
[edit]
[-] ea-php80-pear
[edit]
[-] ea-php84-pear
[edit]
[-] fprintd-enroll
[edit]
[-] systemd-delta
[edit]
[-] modulecmd
[edit]
[-] gxl2gv
[edit]
[-] mariadb-setpermission
[edit]
[-] mknod
[edit]
[-] pidof
[edit]
[-] gvgen
[edit]
[-] link
[edit]
[-] gprof
[edit]
[-] znew
[edit]
[-] lneato
[edit]
[-] sfdp
[edit]
[-] systemd-socket-activate
[edit]
[-] hash
[edit]
[-] scl_enabled
[edit]
[-] fc-cache-64
[edit]
[-] instmodsh
[edit]
[-] uuidgen
[edit]
[-] mysqlbinlog
[edit]
[-] dbus-send
[edit]
[-] pfbtopfa
[edit]
[-] chgrp
[edit]
[-] xzdiff
[edit]
[-] nl-qdisc-list
[edit]
[-] dpkg-maintscript-helper
[edit]
[-] gtroff
[edit]
[-] sg_read
[edit]
[-] gst-inspect-1.0
[edit]
[-] ipcs
[edit]
[-] dpkg-trigger
[edit]
[-] gdbmtool
[edit]
[-] mdb_stat
[edit]
[-] fribidi
[edit]
[-] tbl
[edit]
[-] comm
[edit]
[-] glib-compile-schemas
[edit]
[-] word-list-compress
[edit]
[-] ab
[edit]
[-] systemd-sysusers
[edit]
[-] chcon
[edit]
[-] json_pp
[edit]
[-] turbostat
[edit]
[-] zegrep
[edit]
[-] getopts
[edit]
[-] mysqladmin
[edit]
[-] newuidmap
[edit]
[-] nf-exp-list
[edit]
[-] node
[edit]
[-] arping
[edit]
[-] ipcalc
[edit]
[-] upower
[edit]
[-] openvt
[edit]
[-] xmllint
[edit]
[-] kill
[edit]
[-] skill
[edit]
[-] python3.9-x86_64-config
[edit]
[-] setup-nsssysinit
[edit]
[-] gcc-nm
[edit]
[-] psfaddtable
[edit]
[-] needs-restarting
[edit]
[-] zipsplit
[edit]
[-] pmap
[edit]
[-] nl-util-addr
[edit]
[-] grub2-mount
[edit]
[-] btreplay
[edit]
[-] rm
[edit]
[-] fprintd-list
[edit]
[-] localedef
[edit]
[-] htdigest
[edit]
[-] sg_format
[edit]
[-] nl-tctree-list
[edit]
[-] true
[edit]
[-] nf-ct-add
[edit]
[-] bashbug
[edit]
[-] arpaname
[edit]
[-] lessecho
[edit]
[-] unpigz
[edit]
[-] zcmp
[edit]
[-] nl-qdisc-delete
[edit]
[-] ea-php83-pecl
[edit]
[-] gpic
[edit]
[-] osinfo-db-import
[edit]
[-] ccomps
[edit]
[-] xmlwf
[edit]
[-] sg_sanitize
[edit]
[-] gpg-wks-server
[edit]
[-] mariadb-show
[edit]
[-] systemd-tty-ask-password-agent
[edit]
[-] tclsh8.6
[edit]
[-] protoc-c
[edit]
[-] bzmore
[edit]
[-] run-with-aspell
[edit]
[-] lscpu
[edit]
[-] scsi_readcap
[edit]
[-] rpm2cpio
[edit]
[-] reset
[edit]
[-] bzip2
[edit]
[-] m4
[edit]
[-] gst-typefind-1.0
[edit]
[-] rpmkeys
[edit]
[-] setleds
[edit]
[-] unicode_stop
[edit]
[-] dnf
[edit]
[-] nl-route-add
[edit]
[-] addr2line
[edit]
[-] nf-monitor
[edit]
[-] png-fix-itxt
[edit]
[-] orc-bugreport
[edit]
[-] sg_reset
[edit]
[-] grotty
[edit]
[-] pipewire-avb
[edit]
[-] ea-php80-pecl
[edit]
[-] teamnl
[edit]
[-] GET
[edit]
[-] domainname
[edit]
[-] nf-ct-events
[edit]
[-] colrm
[edit]
[-] exempi
[edit]
[-] stty
[edit]
[-] vmstat
[edit]
[-] pkla-check-authorization
[edit]
[-] grub2-editenv
[edit]
[-] zgrep
[edit]
[-] ncurses6-config
[edit]
[-] flatpak-bisect
[edit]
[-] sg_copy_results
[edit]
[-] gpg-wks-client
[edit]
[-] msgfmt
[edit]
[-] tree
[edit]
[-] sg_wr_mode
[edit]
[-] shasum
[edit]
[-] ld.so
[edit]
[-] nl-link-stats
[edit]
[-] top
[edit]
[-] HEAD
[edit]
[-] envsubst
[edit]
[-] xargs
[edit]
[-] dirname
[edit]
[-] crontab
[edit]
[-] chacl
[edit]
[-] json_verify
[edit]
[-] h2xs
[edit]
[-] x86_64
[edit]
[-] imunify360-agent
[edit]
[-] tar
[edit]
[-] netstat
[edit]
[-] perldoc
[edit]
[-] sedispol
[edit]
[-] curl
[edit]
[-] tput
[edit]
[-] pod2man
[edit]
[-] ex
[edit]
[-] ea-php83-pear
[edit]
[-] dig
[edit]
[-] cat
[edit]
[-] getfacl
[edit]
[-] pidstat
[edit]
[-] osql
[edit]
[-] msgexec
[edit]
[-] vdosetuuid
[edit]
[-] manpath
[edit]
[-] bootconfig
[edit]
[-] bluemoon
[edit]
[-] luac
[edit]
[-] corelist
[edit]
[-] pdf2dsc
[edit]
[-] setterm
[edit]
[-] nf-log
[edit]
[-] sim_lsmplugin
[edit]
[-] osinfo-db-path
[edit]
[-] localectl
[edit]
[-] sg_rtpg
[edit]
[-] ea-php83
[edit]
[-] idiag-socket-details
[edit]
[-] sg_luns
[edit]
[-] msgfmt3.9.py
[edit]
[-] less
[edit]
[-] fc-scan
[edit]
[-] test
[edit]
[-] pigz
[edit]
[-] filan
[edit]
[-] pip
[edit]
[-] grub2-file
[edit]
[-] quotasync
[edit]
[-] rsync
[edit]
[-] mariadb-embedded
[edit]
[-] sg_verify
[edit]
[-] mkdir
[edit]
[-] dwz
[edit]
[-] alias
[edit]
[-] stdbuf
[edit]
[-] pwdx
[edit]
[-] automake
[edit]
[-] patchwork
[edit]
[-] grub2-mkrelpath
[edit]
[-] pydoc3.9
[edit]
[-] jobs
[edit]
[-] grub2-mkfont
[edit]
[-] gresource
[edit]
[-] gvpr
[edit]
[-] sg_stream_ctl
[edit]
[-] msgattrib
[edit]
[-] sieve-filter
[edit]
[-] script
[edit]
[-] wsrep_sst_backup
[edit]
[-] xml2-config
[edit]
[-] expand
[edit]
[-] tred
[edit]
[-] sg_write_same
[edit]
[-] xdg-mime
[edit]
[-] getent
[edit]
[-] killall
[edit]
[-] watchgnupg
[edit]
[-] iio_generic_buffer
[edit]
[-] vdir
[edit]
[-] gsoelim
[edit]
[-] cp
[edit]
[-] sg_reset_wp
[edit]
[-] systemd-cgls
[edit]
[-] sg_referrals
[edit]
[-] fc-list
[edit]
[-] base32
[edit]
[-] lua
[edit]
[-] bzless
[edit]
[-] xzless
[edit]
[-] patch
[edit]
[-] mariadb_config
[edit]
[-] b2sum
[edit]
[-] glib-compile-resources
[edit]
[-] systemd-cryptenroll
[edit]
[-] ea-php82
[edit]
[-] basename
[edit]
[-] gtk-query-immodules-2.0-64
[edit]
[-] unicode_start
[edit]
[-] sg_xcopy
[edit]
[-] objcopy
[edit]
[-] nsupdate
[edit]
[-] scsi-rescan
[edit]
[-] nl-addr-delete
[edit]
[-] tzselect
[edit]
[-] event_rpcgen.py
[edit]
[-] post-grohtml
[edit]
[-] mariadb-config
[edit]
[-] mysqlshow
[edit]
[-] perlml
[edit]
[-] libtool
[edit]
[-] gsnd
[edit]
[-] mariadb-service-convert
[edit]
[-] gtester-report
[edit]
[-] nc
[edit]
[-] touch
[edit]
[-] mariadb-check
[edit]
[-] shred
[edit]
[-] dbus-broker
[edit]
[-] mdig
[edit]
[-] dbilogstrip
[edit]
[-] perlivp
[edit]
[-] gzexe
[edit]
[-] graphml2gv
[edit]
[-] gmake
[edit]
[-] tsort
[edit]
[-] peekfd
[edit]
[-] env
[edit]
[-] grub2-mkstandalone
[edit]
[-] distro
[edit]
[-] iio_event_monitor
[edit]
[-] odbcinst
[edit]
[-] gunzip
[edit]
[-] nproc
[edit]
[-] lsinitrd
[edit]
[-] pwscore
[edit]
[-] xzdec
[edit]
[-] sg_rep_pip
[edit]
[-] sg_read_block_limits
[edit]
[-] ls
[edit]
[-] pure-statsdecode
[edit]
[-] kbdrate
[edit]
[-] grub2-kbdcomp
[edit]
[-] git-shell
[edit]
[-] kvm_stat
[edit]
[-] dos2unix
[edit]
[-] sg_turs
[edit]
[-] gpg
[edit]
[-] gv2gml
[edit]
[-] mysqld_safe_helper
[edit]
[-] npm
[edit]
[-] mysql_config
[edit]
[-] pip-3
[edit]
[-] gvmap
[edit]
[-] rpm
[edit]
[-] pod2usage
[edit]
[-] msgfmt3.py
[edit]
[-] nop
[edit]
[-] last
[edit]
[-] mysql
[edit]
[-] deallocvt
[edit]
[-] msql2mysql
[edit]
[-] sg_get_elem_status
[edit]
[-] pidwait
[edit]
[-] grub2-menulst2cfg
[edit]
[-] evmctl
[edit]
[-] lchsh
[edit]
[-] cd
[edit]
[-] dovecot-sysreport
[edit]
[-] aulast
[edit]
[-] groups
[edit]
[-] rescan-scsi-bus.sh
[edit]
[-] gapplication
[edit]
[-] more
[edit]
[-] bsqldb
[edit]
[-] os-prober
[edit]
[-] fc-conflist
[edit]
[-] mm2gv
[edit]
[-] prezip-bin
[edit]
[-] python3.9-config
[edit]
[-] whereis
[edit]
[-] mysqldump
[edit]
[-] make-dummy-cert
[edit]
[-] precat
[edit]
[-] imunify-fgw-dump
[edit]
[-] systemd-hwdb
[edit]
[-] read
[edit]
[-] dot2gxl
[edit]
[-] tclsh
[edit]
[-] pldd
[edit]
[-] [
[edit]
[-] gio
[edit]
[-] btmgmt
[edit]
[-] man.man-db
[edit]
[-] bzegrep
[edit]
[-] POST
[edit]
[-] scsi_mandat
[edit]
[-] x86_energy_perf_policy
[edit]
[-] rvim
[edit]
[-] sed
[edit]
[-] scsi_satl
[edit]
[-] fallocate
[edit]
[-] nl-rule-list
[edit]
[-] updatedb
[edit]
[-] setvtrgb
[edit]
[-] paperconf
[edit]
[-] osinfo-db-export
[edit]
[-] lsirq
[edit]
[-] resolve_stack_dump
[edit]
[-] sg_rep_zones
[edit]
[-] ispell
[edit]
[-] lwp-mirror
[edit]
[-] sginfo
[edit]
[-] glib-gettextize
[edit]
[-] gsf-office-thumbnailer
[edit]
[-] desktop-file-validate
[edit]
[-] diff3
[edit]
[-] cut
[edit]
[-] osinfo-install-script
[edit]
[-] s-nail
[edit]
[-] chrt
[edit]
[-] systemd-creds
[edit]
[-] ypdomainname
[edit]
[-] sg_read_long
[edit]
[-] bzip2recover
[edit]
[-] tr
[edit]
[-] passwd
[edit]
[-] gsdj
[edit]
[-] lslogins
[edit]
[-] fisql
[edit]
[-] mysql_waitpid
[edit]
[-] xdg-screensaver
[edit]
[-] gsbj
[edit]
[-] bcomps
[edit]
[-] perror
[edit]
[-] ln
[edit]
[-] ps2epsi
[edit]
[-] msgen
[edit]
[-] nslookup
[edit]
[-] grops
[edit]
[-] atrm
[edit]
[-] basenc
[edit]
[-] atq
[edit]
[-] prlimit
[edit]
[-] ps2ps
[edit]
[-] zsoelim
[edit]
[-] semodule_package
[edit]
[-] sm3hmac
[edit]
[-] sg_inq
[edit]
[-] nl-cls-delete
[edit]
[-] sg_rbuf
[edit]
[-] teamd
[edit]
[-] btrace
[edit]
[-] who
[edit]
[-] gtar
[edit]
[-] audit2why
[edit]
[-] dracut
[edit]
[-] ptardiff
[edit]
[-] kmod
[edit]
[-] apropos
[edit]
[-] gtk-query-immodules-3.0-64
[edit]
[-] join
[edit]
[-] tracker3
[edit]
[-] sg_write_verify
[edit]
[-] gpio-event-mon
[edit]
[-] pslog
[edit]
[-] socat
[edit]
[-] prove
[edit]
[-] systemd-path
[edit]
[-] sg_opcodes
[edit]
[-] sg_ses
[edit]
[-] mesg
[edit]
[-] dbus-broker-launch
[edit]
[-] timedatectl
[edit]
[-] xzcmp
[edit]
[-] setfont
[edit]
[-] nl-pktloc-lookup
[edit]
[-] ssh-agent
[edit]
[-] sha256hmac
[edit]
[-] xdg-open
[edit]
[-] aulastlog
[edit]
[-] printf
[edit]
[-] nl-cls-add
[edit]
[-] ncursesw6-config
[edit]
[-] apropos.man-db
[edit]
[-] elfedit
[edit]
[-] gpg-error
[edit]
[-] mapscrn
[edit]
[-] tcptraceroute
[edit]
[-] update-gtk-immodules
[edit]
[-] debuginfo-install
[edit]
[-] cvtsudoers
[edit]
[-] su
[edit]
[-] iostat
[edit]
[-] sg_scan
[edit]
[-] vdodmeventd
[edit]
[-] pdns_control
[edit]
[-] mktemp
[edit]
[-] dd
[edit]
[-] mariadb-access
[edit]
[-] msgcat
[edit]
[-] umount
[edit]
[-] dpkg-query
[edit]
[-] du
[edit]
[-] chmem
[edit]
[-] sg_readcap
[edit]
[-] zipgrep
[edit]
[-] c99
[edit]
[-] sg_modes
[edit]
[-] ea-php80
[edit]
[-] prtstat
[edit]
[-] fusermount
[edit]
[-] wdctl
[edit]
[-] imunify-service
[edit]
[-] vim
[edit]
[-] gpio-hammer
[edit]
[-] gobject-query
[edit]
[-] dot
[edit]
[-] showconsolefont
[edit]
[-] rename
[edit]
[-] nl-monitor
[edit]
[-] wsrep_sst_common
[edit]
[-] traceroute6
[edit]
[-] mariadb-secure-installation
[edit]
[-] cpapi1
[edit]
[-] x86_64-redhat-linux-gnu-pkg-config
[edit]
[-] cpapi3
[edit]
[-] ea-php82-pear
[edit]
[-] rpcbind
[edit]
[-] paste
[edit]
[-] readelf
[edit]
[-] x86_64-redhat-linux-c++
[edit]
[-] sg_prevent
[edit]
[-] replace
[edit]
[-] gst-launch-1.0
[edit]
[-] dltest
[edit]
[-] pure-pw
[edit]
[-] ps
[edit]
[-] my_print_defaults
[edit]
[-] git-upload-archive
[edit]
[-] chmod
[edit]
[-] systemd-notify
[edit]
[-] systemd-cgtop
[edit]
[-] nl-link-enslave
[edit]
[-] bsqlodbc
[edit]
[-] loadkeys
[edit]
[-] twopi
[edit]
[-] timeout
[edit]
[-] desktop-file-install
[edit]
[-] xz
[edit]
[-] irqtop
[edit]
[-] pipewire-vulkan
[edit]
[-] hex2hcd
[edit]
[-] mariadb-install-db
[edit]
[-] diffimg
[edit]
[-] preunzip
[edit]
[-] getopt
[edit]
[-] whatis
[edit]
[-] uuidparse
[edit]
[-] ea-php82-pecl
[edit]
[-] locale
[edit]
[-] repoclosure
[edit]
[-] pkcheck
[edit]
[-] mysql_tzinfo_to_sql
[edit]
[-] compare
[edit]
[-] cluster
[edit]
[-] vi
[edit]
[-] gtbl
[edit]
[-] sedismod
[edit]
[-] fips-finish-install
[edit]
[-] pwd
[edit]
[-] tty
[edit]
[-] avinfo
[edit]
[-] lsusb.py
[edit]
[-] sha1hmac
[edit]
[-] setarch
[edit]
[-] dirmngr-client
[edit]
[-] ssltap
[edit]
[-] logresolve
[edit]
[-] btt
[edit]
[-] sg_senddiag
[edit]
[-] nl-neigh-delete
[edit]
[-] c++filt
[edit]
[-] ima-add-sigs
[edit]
[-] ssh
[edit]
[-] rsync-ssl
[edit]
[-] sudoedit
[edit]
[-] pstree.x11
[edit]
[-] gettext
[edit]
[-] sg_get_lba_status
[edit]
[-] wmf2x
[edit]
[-] pygettext3.9.py
[edit]
[-] sg_requests
[edit]
[-] mariadbd-safe
[edit]
[-] config_data
[edit]
[-] rpm2archive
[edit]
[-] lwp-request
[edit]
[-] kbd_mode
[edit]
[-] zipinfo
[edit]
[-] lefty
[edit]
[-] fgrep
[edit]
[-] x86_64-redhat-linux-g++
[edit]
[-] pathfix3.9.py
[edit]
[-] wait
[edit]
[-] pathfix.py
[edit]
[-] ionice
[edit]
[-] vdoformat
[edit]
[-] vdostats
[edit]
[-] as
[edit]
[-] python3-html2text
[edit]
[-] desktop-file-edit
[edit]
[-] attr
[edit]
[-] ac
[edit]
[-] scsi_logging_level
[edit]
[-] wmf2eps
[edit]
[-] pkaction
[edit]
[-] idn
[edit]
[-] g13
[edit]
[-] fprintd-verify
[edit]
[-] gpg-agent
[edit]
[-] lsmcli
[edit]
[-] wmf2gd
[edit]
[-] pod2text
[edit]
[-] ftp
[edit]
[-] nl-neigh-add
[edit]
[-] mysqlcheck
[edit]